#include <Trade/Trade.mqh>

input int Magic = 2; // Mn.

int barsTotal;
CTrade trade;

int handles[];

string symbols[] = {
   "AUDUSD_",
   "EURUSD_",
   "GBPUSD_",
   "USDCAD_",
   "USDCHF_",
   "USDJPY_",
};

double volumes[] = {
   0.01,
   0.01,
   0.01,
   0.01,
   0.01,
   0.01,

};
int OnInit(){
   ArrayResize(handles,ArraySize(symbols));
   for(int i = 0; i < ArraySize(symbols); i++){
      handles[i] = iRSI(symbols[i],PERIOD_CURRENT,14,PRICE_CLOSE);
   }
   
   trade.SetExpertMagicNumber(Magic);

   return(INIT_SUCCEEDED);
}

void OnDeinit(const int reason){

   
}

void OnTick(){

   int bars = iBars(_Symbol,PERIOD_CURRENT);
   if(barsTotal < bars){
   barsTotal = bars;
   
      for(int i = 0; i < ArraySize(symbols); i++){
         doStuff(symbols[i],handles[i],volumes[i]);
      }
   }      
}

void doStuff(string symbol, int handle, double volume){
   double rsi[];
   CopyBuffer(handle,MAIN_LINE,1,1,rsi);
   
   bool isRsiBuy = rsi[0] < 30;
   bool isRsiSell = rsi[0] > 70;
   
   for(int i = PositionsTotal()-1; i >= 0; i--){
      ulong posTicket = PositionGetTicket(i);
      if(PositionGetString(POSITION_SYMBOL) == symbol && PositionGetInteger(POSITION_MAGIC) == Magic){
         if(PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_BUY){
            if(isRsiSell){
               trade.PositionClose(posTicket);
            }
            isRsiSell = false;
         }else if(PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_SELL){
            if(isRsiBuy){
               trade.PositionClose(posTicket);
            }
            isRsiSell = false;
         }
      }
   }
   
   if(isRsiSell){
      trade.Sell(volume,symbol);
   }else if(isRsiBuy){
      trade.Buy(volume,symbol);
   }
}                      

